# ConfigMysql

from config import __CONFIG__

import mysql.connector

mysql_config = {
    'user': __CONFIG__['mysql_user'],
    'password': __CONFIG__['mysql_password'],
    'host': __CONFIG__['mysql_host'],  # Typically 'localhost' if the database is on the same machine
    'database': 'fastdoi',
    'raise_on_warnings': True,
    'auth_plugin':'mysql_native_password'
}

# Establish a connection to the MySQL database
cnx = mysql.connector.connect(**mysql_config)
cursor = cnx.cursor()

def end_mysql():
    try:
        # Close the cursor and connection
        cursor.close()
        cnx.close()
    except:
        print("No Mysql Opened.")

def is_loaded(paperId):
    query = ("SELECT COUNT(*) FROM uploaded_papers WHERE paperId = %s")
    cursor.execute(query, (paperId,))
    return cursor.fetchone()[0] > 0

def new_load(paperId):
    query = ("INSERT INTO uploaded_papers (paperId) VALUES (%s)")
    cursor.execute(query, (paperId,))    
    cnx.commit()
